<template>
    <v-row justify="center">
        <v-col cols="12" sm="8">
            <v-card class="elevation-3">
                <Loading :visible="isLoading" />
                <v-card-title>
                    <v-icon>
                        mdi-store
                    </v-icon>
                    Informations Entreprise
                </v-card-title>
                <v-list-item>
                    <v-list-item-content>
                        <v-form>
                            <v-list-item>
                                <v-list-item-content>
                                    <v-file-input v-model="imageLogo" accept="image/*" id="logo"
                                        label="Logo de votre entreprise" name="logo" @change="uploadImage"
                                        prepend-icon="mdi-camera" :disabled="!editMode">
                                    </v-file-input>
                                </v-list-item-content>
                                <v-list-item-avatar tile size="150" color="grey" rounded>
                                    <v-img :src="imageUrl" alt="Logo entreprise">
                                    </v-img>
                                </v-list-item-avatar>

                            </v-list-item>
                            <v-list-item>
                                <v-text-field id="name" v-model="companyInfos.name" label="Nom de l'entreprise"
                                    class="input-field" :error-messages="nameErrors" dense :disabled="!editMode">
                                </v-text-field>
                            </v-list-item>
                            <v-list-item>
                                <v-text-field id="street" v-model="companyInfos.street" label="Adresse"
                                    :error-messages="streetErrors" class="input-field" dense :disabled="!editMode">
                                </v-text-field>
                            </v-list-item>
                            <v-list-item>
                                <v-row>
                                    <v-col cols="8">
                                        <v-text-field id="city" v-model="companyInfos.city" label="Ville"
                                            :error-messages="cityErrors" class="input-field" dense
                                            :disabled="!editMode">
                                        </v-text-field>
                                    </v-col>
                                    <v-col cols="4">
                                        <v-text-field id="zc" v-model="companyInfos.zc" label="Code postal"
                                            :error-messages="zcErrors" class="input-field" dense :disabled="!editMode">
                                        </v-text-field>
                                    </v-col>
                                </v-row>
                            </v-list-item>
                            <v-list-item>
                                <v-text-field id="country" v-model="companyInfos.country" label="Pays"
                                    :error-messages="countryErrors" class="input-field" dense :disabled="!editMode">
                                </v-text-field>
                            </v-list-item>
                            <v-list-item>
                                <v-text-field id="siret" v-model="companyInfos.siret" label="Siret de l'entreprise"
                                    :error-messages="siretErrors" class="input-field" dense :disabled="!editMode">
                                </v-text-field>
                            </v-list-item>
                            <v-card-actions>
                                <div v-if="editMode">
                                    <v-btn color="secondary" light type="submit" @click="saveInfos">
                                        Sauvegarder
                                    </v-btn>
                                </div>
                                <div v-else>
                                    <v-btn color="secondary" light @click="editProfile">
                                        Editer
                                    </v-btn>
                                </div>
                            </v-card-actions>
                        </v-form>
                    </v-list-item-content>
                </v-list-item>
            </v-card>
        </v-col>

    </v-row>
</template>

<script>
import { ENTRYPOINT } from '../../config/entrypoint';
import { mapFields } from 'vuex-map-fields';
import { mapActions } from 'vuex';
import {
  validationMixin
} from 'vuelidate';
import {
  required,
  minLength
} from 'vuelidate/lib/validators';
import NotificationMixin from '../../mixins/NotificationMixin';
import Loading from '../../components/Loading';
// import LoginForm from '../../components/login/LoginForm';
const servicePrefix = 'User';

export default {
  name: 'AdminCompanyView',
  mixins: [NotificationMixin, validationMixin],
  servicePrefix,
  components: {
    // LoginForm,
    Loading
  },
  validations: {
    companyInfos: {    
      name: {
        required,
        minLength: minLength(3)
      },
      logo: {
        required
      },
      street: {
        required
      },
      city: {
        required
      },
      country: {
        required
      },
      zc: {
        required
      },
      siret: {
        required,
        minLength: minLength(3)
      },
    }
  },
  data() {
    return {
      companyInfos: {
        name: '',
        logo:'',
        street: '',
        city: '',
        country: '',
        zc: '',
        siret: '',
      },
      imageUrl: '',
      imageLogo: null,
      editMode: false,
      isLoading: false
    }
  },
  computed: {
    logoErrors() {
      const errors = [];
      if (!this.$v.companyInfos.logo.$dirty) return errors
      !this.$v.companyInfos.logo.required && errors.push('Logo de l\'entreprise requis')
      return errors
    },
    nameErrors() {
      const errors = [];
      if (!this.$v.companyInfos.name.$dirty) return errors
      !this.$v.companyInfos.name.required && errors.push('Nom de l\'entreprise requis')
      return errors
    },
    streetErrors() {
      const errors = [];
      if (!this.$v.companyInfos.street.$dirty) return errors
      !this.$v.companyInfos.street.required && errors.push('Adresse requise')
      return errors
    },
    cityErrors() {
      const errors = [];
      if (!this.$v.companyInfos.city.$dirty) return errors
      !this.$v.companyInfos.city.required && errors.push('Ville requise')
      return errors
    },
    countryErrors() {
      const errors = [];
      if (!this.$v.companyInfos.country.$dirty) return errors
      !this.$v.companyInfos.country.required && errors.push('Pays requis')
      return errors
    },
    zcErrors() {
      const errors = [];
      if (!this.$v.companyInfos.zc.$dirty) return errors
      !this.$v.companyInfos.zc.required && errors.push('Code postal requis')
      return errors
    },
    siretErrors() {
      const errors = [];
      if (!this.$v.companyInfos.siret.$dirty) return errors
      !this.$v.companyInfos.siret.required && errors.push('Le Siret requis')
      return errors
    },
    ...mapFields('user', ['userInfos', 'loggedIn', 'tempProfilePicture']),
    ...mapFields('admin', ['company', 'companyFound']),

  },
  created() {
    if (this.companyFound) {
      this.companyInfos = this.company;
      if (!this.imageUrl && this.companyInfos.logo) {
        this.imageUrl = ENTRYPOINT + '/media/' +  this.companyInfos.logo.filePath;
      }
    }
  },
  methods: {
    editProfile() {
      event.preventDefault();
      this.editMode = true;
    },
    saveInfos() {
      event.preventDefault();
      this.$v.$touch();
      if (this.$v.$invalid) {
        return false;
      }
      
      if (this.companyFound) {
        this.updateCompany(this.companyInfos);
      } else {
        let newCompany = {
          ...this.companyInfos,
          renters: ['/users/' + this.userInfos.id]
        }
        this.createCompany(newCompany);
      }
      this.editMode = !this.editMode;
    },
    uploadImage:function() {
      let formData = new FormData();
      formData.append('file', this.imageLogo, this.imageLogo.name);
      this.uploadProfilePicture(formData);
    },
    // handleLogin(value) {
    //   this.login(value)
    // },
    ...mapActions('admin', ['getCompanyInfosByOwner', 'createCompany', 'updateCompany']),
    ...mapActions('user', [ 'uploadProfilePicture'])
    
  },
  watch: {
    company(newData) {
      if (newData) {
        this.companyInfos = {...newData};
        if (!this.imageUrl && newData.logo) {
          this.imageUrl = ENTRYPOINT + '/media/' +  newData.logo.filePath;
        }
      }
    },
    tempProfilePicture(newPicture) {
      if (newPicture) {
        this.companyInfos['logo'] = newPicture.imageId;
        this.imageUrl = ENTRYPOINT + newPicture.imageUrl;
      }
    }
  }
};
</script>
